#! /usr/bin/python
# Author(s): Keeguon
import os, re
import subprocess
import pygtk
pygtk.require('2.0')

import gtk, gobject, gconf

# Variables
backend = 'ccp'

fading = 0
shadows = 0

fast_filter = 0
indirect_rendering = 1
loose_binding = 1

# Get current processes
processes = os.popen("ps -A").read()

# Fallback decorators and respective commands to run when not using Compiz
std_decorators = {'gnome-session':'metacity --replace', 'dcop':'kwin --replace'} 
for session, decorator in std_decorators.iteritems():
	if re.search(session, processes):
		std_decor_to_run = decorator 

def fallback_decorator():
	os.system(std_decor_to_run)

# GL Decorators
gl_decor_to_run = ''
gl_decorators = {'gnome-session':'gtk-window-decorator --replace', 'dcop':'kde-window-decorator --replace'}
for session, gl_decorator in gl_decorators.iteritems():
	if re.search(session, processes):
		gl_decor_to_run = gl_decorator

def gl_decorator():
	os.system(gl_decor_to_run)

decorator = gl_decor_to_run

# Get installed application
app_is_installed = []
apps = ('compiz.real', 'compiz-settings', 'ccs-settings' , 'gtk-window-decorator', 'kde-window-decorator', 'emerald' , 'metacity', 'kwin', 'xcompmgr') # Supported apps

for application in apps:
	if os.system("which " + application) == 0:
		app_is_installed.append(application)
	
def installed(app):
	global app_is_installed
	return app in app_is_installed

# Check if gwd runs with cairo or metacity
gwd_backend = gconf.client_get_default()
metacity_theme_active = gwd_backend.get_bool('/apps/gwd/use_metacity_theme')

# Start decorator
def start_decorator_default():
	if installed('compiz.real'):
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--indirect-rendering' , '--loose-binding' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	else:
		fallback_decorator()

# Menu Configuration
def configure_menu_activate(widget):
	if installed('ccs-settings') and backend == 'ccp':
		gobject.spawn_async(['ccs-settings'], flags=gobject.SPAWN_SEARCH_PATH)
	elif installed('compiz-settings') and backend == 'gconf':
		gobject.spawn_async(['compiz-settings'], flags=gobject.SPAWN_SEARCH_PATH)
	elif backend == 'ccp':
		subprocess.Popen(['nautilus' , './.ccs'])
	else:
		gobject.spawn_async(['gconf-editor'], flags=gobject.SPAWN_SEARCH_PATH)

def etm_menu_activate(widget):
	subprocess.Popen(['emerald-theme-manager'])

def gconf_menu_activate(widget):
	global backend
	if widget.get_active():
		backend = 'gconf'
	else:
		backend = 'ccp'

def compiz_fast_filter(widget):
	global fast_filter
	if option_fastfilter.get_active():
		fast_filter = 1
	else:
		fast_filter = 0

def compiz_indirect_rendering(widget):
	global indirect_rendering
	if option_indirectrendering.get_active():
		indirect_rendering = 1
	else:
		indirect_rendering = 0

def compiz_loose_binding(widget):
	global loose_binding
	if option_loosebinding.get_active():
		loose_binding = 1
	else:
		loose_binding = 0

def compiz_menu_activate(widget):
	if fast_filter == 0 and indirect_rendering == 0 and loose_binding == 0:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 1 and indirect_rendering == 0 and loose_binding == 0:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--fast-filter' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 0 and indirect_rendering == 1 and loose_binding == 0:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--indirect-rendering' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 0 and indirect_rendering == 0 and loose_binding == 1:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--loose-binding' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 1 and indirect_rendering == 1 and loose_binding == 0:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--fast-filter' , '--indirect-rendering' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 1 and indirect_rendering == 0 and loose_binding == 1:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--fast-filter' , '--loose-binding' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 0 and indirect_rendering == 1 and loose_binding == 1:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--indirect-rendering' , '--loose-binding' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])
	if fast_filter == 1 and indirect_rendering == 1 and loose_binding == 1:
		subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
		subprocess.Popen(['compiz.real' , '--replace' , '--sm-disable' , '--fast_filter' , '--indirect-rendering' , '--loose-binding' , backend])
		if decorator == 'gtk-window-decorator --replace':
			subprocess.Popen(['gtk-window-decorator' , '--replace'])
		if decorator == 'kde-window-decorator --replace':
			subprocess.Popen(['kde-window-decorator' , '--replace'])
		if decorator == 'emerald --replace':
			subprocess.Popen(['emerald' , '--replace'])

def gtkwd_menu_activate(widget):
	global decorator
	decorator = 'gtk-window-decorator --replace'
	subprocess.Popen(['killall' , 'gtk-window-decorator', 'kde-window-decorator', 'emerald', 'metacity', 'kwin', 'xcompmgr'])
	subprocess.Popen(['gtk-window-decorator',  '--replace'])

def use_metacity_activate(widget):
	global metacity_theme_active
	global use_metacity
	is_metacity_theme = use_metacity_theme.get_active()
	if is_metacity_theme == True:
		use_metacity = gwd_backend.set_bool('/apps/gwd/use_metacity_theme', True)
		metacity_theme_active = gwd_backend.get_bool('/apps/gwd/use_metacity_theme')
	else:
		use_metacity = gwd_backend.set_bool('/apps/gwd/use_metacity_theme', False)
		metacity_theme_active = gwd_backend.get_bool('/apps/gwd/use_metacity_theme')

def kdewd_menu_activate(widget):
	global decorator
	decorator = 'kde-window-decorator --replace'
	subprocess.Popen(['killall' , 'gtk-window-decorator', 'kde-window-decorator', 'emerald', 'metacity', 'kwin', 'xcompmgr'])
	subprocess.Popen(['kde-window-decorator',  '--replace'])

def emerald_menu_activate(widget):
	global decorator
	decorator = 'emerald --replace'
	subprocess.Popen(['killall' , 'gtk-window-decorator', 'kde-window-decorator', 'emerald', 'metacity', 'kwin', 'xcompmgr'])
	subprocess.Popen(['emerald',  '--replace'])

def metacity_menu_activate(widget):
	subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
	subprocess.Popen(['metacity' , '--replace'])

def kwin_menu_activate(widget):
	subprocess.Popen(['killall' , 'compiz.real' , 'gtk-window-decorator' , 'kde-window-decorator' , 'emerald' , 'metacity' , 'kwin'])
	subprocess.Popen(['kwin' , '--replace'])

def about_window(widget):
	# About Window
	about_window = gtk.Window(type=gtk.WINDOW_TOPLEVEL)
	about_window.set_title('About - Go-Compiz Tray Icon')
	about_window.set_default_size(400, 252)
	about_window.set_position(gtk.WIN_POS_CENTER)

	# Vbox
	vbox = gtk.VBox(False, 0)
	about_window.add(vbox)

	# Compiz Logo
	compiz_logo = gtk.Image()
	compiz_logo.set_from_file('/usr/share/go-compiz_compiz.real/img/compiz_logo.png')

	# Title Text
	title_text = gtk.Label()
	title_text.set_markup(
	'<span size="xx-large"><b>Go-Compiz Tray Icon v0.5.2</b></span>'
	)
	title_text.set_justify(gtk.JUSTIFY_CENTER)

	# Undertitle Text
	undertitle_text = gtk.Label()
	undertitle_text.set_markup(
	'User friendly launcher for Compiz\n\n'
	'Using OpenCompositing (compiz/compcomm)'
	)
	undertitle_text.set_justify(gtk.JUSTIFY_CENTER)

	# Author Text
	author_text = gtk.Label()
	author_text.set_markup(
	'<small>Copyleft - 2007 - F. Bellanger</small>'
	)
	undertitle_text.set_justify(gtk.JUSTIFY_CENTER)

	# Buttons
	hbox_buttons = gtk.HBox(False, 0)

	credits_button = gtk.Button(' _Credits', use_underline=True)
	credits_image = gtk.Image()
	credits_image.set_from_stock(gtk.STOCK_ABOUT, gtk.ICON_SIZE_BUTTON)
	credits_button.set_image(credits_image)
	credits_button.connect("clicked", credits_window)
	quit_button = gtk.Button(stock=gtk.STOCK_CLOSE)
	quit_button.connect("clicked", lambda x: about_window.destroy())
	quit_alignment = gtk.Alignment(1, 0, 0, 0)
	quit_alignment.add(quit_button)

	hbox_buttons.pack_start(credits_button, False, False, 5)
	hbox_buttons.pack_start(quit_alignment, True, True, 5)

	# Adding elements to the Vbox
	vbox.pack_start(compiz_logo, False, False, 5)
	vbox.pack_start(title_text, False, False, 5)
	vbox.pack_start(undertitle_text, False, False, 5)
	vbox.pack_start(author_text, False, False, 5)
	vbox.pack_start(hbox_buttons, False, False, 5)

	about_window.show_all()

def credits_window(widget):
	# Credits Window
	credits_window = gtk.Window(type=gtk.WINDOW_TOPLEVEL)
	credits_window.set_title('Credits - Go-Compiz Tray Icon')
	credits_window.set_default_size(350, 275)
	credits_window.set_position(gtk.WIN_POS_CENTER)

	# Vbox for Credits Window
	vbox_credits = gtk.VBox(False, 0)
	credits_window.add(vbox_credits)

	# Written by tab
	writtenby_frame = gtk.Frame()
	writtenby_frame.set_shadow_type(gtk.SHADOW_OUT)
	writtenby_textarea = gtk.TextView()
	writtenby_textarea.set_editable(False)
	writtenby_textarea.set_size_request(0, 185)
	writtenby_buffer = writtenby_textarea.get_buffer()
	writtenby_buffer.set_text('Felix Bellanger <keeguon@gmail.com>')
	activate_scroll = gtk.ScrolledWindow()
	activate_scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	activate_scroll.add(writtenby_textarea)
	writtenby_frame.add(activate_scroll)

	# Set Tab box
	writtenby_label = gtk.Label('Written by')
	tab_box = gtk.Notebook()
	tab_box.append_page(writtenby_frame, tab_label=writtenby_label)

	# Close button
	close_button = gtk.Button(stock=gtk.STOCK_CLOSE)
	close_button.connect("clicked", lambda x: credits_window.destroy())
	close_alignment = gtk.Alignment(1, 0, 0, 0)
	close_alignment.add(close_button)

	# Append elements to Credits Window via Vbox
	vbox_credits.pack_start(tab_box, False, True, 10)
	vbox_credits.pack_start(close_alignment, False, True, 0)

	# Show Credits Window
	credits_window.show_all()

def quit_menu_activate(widget):
	gtk.main_quit()

def go_compiz_menu(widget, button, time, data = None):
     if button == 3:
         if data:
             data.show_all()
             data.popup(None, None, None, 3, time)
     pass

# Compiz Options
compiz_menu = gtk.Menu()
option_fastfilter = gtk.CheckMenuItem(" Fast Filter")
option_fastfilter.connect("toggled", compiz_fast_filter)
compiz_menu.append(option_fastfilter)
option_indirectrendering = gtk.CheckMenuItem(" Indirect Rendering")
option_indirectrendering.set_active(True)
option_indirectrendering.connect("toggled", compiz_indirect_rendering)
compiz_menu.append(option_indirectrendering)
option_loosebinding = gtk.CheckMenuItem(" Loose Binding")
option_loosebinding.set_active(True)
option_loosebinding.connect("toggled", compiz_loose_binding)
compiz_menu.append(option_loosebinding)

# Compiz Backend
backend_menu = gtk.Menu()
ccp_backend = gtk.RadioMenuItem(label=" CCP Backend")
ccp_backend.set_active(True)
backend_menu.append(ccp_backend)
gconf_backend = gtk.RadioMenuItem(label=" Gconf Backend")
gconf_backend.set_group(ccp_backend)
gconf_backend.connect("activate", gconf_menu_activate)
backend_menu.append(gconf_backend)

# Window decorator
decorator_menu = gtk.Menu()
if installed('emerald'):
	emerald_decorator = gtk.RadioMenuItem(label=" Emerald")
	emerald_decorator.connect("activate", emerald_menu_activate)
	decorator_menu.append(emerald_decorator)
if installed('kde-window-decorator'):
	kdewd_decorator = gtk.RadioMenuItem(label=" KDE Window Decorator")
	kdewd_decorator.set_group(emerald_decorator)
	kdewd_decorator.connect("activate", kdewd_menu_activate)
	if gl_decor_to_run == "kde-window-decorator --replace":
		kdewd_decorator.set_active(True)
	decorator_menu.append(kdewd_decorator)
if installed('gtk-window-decorator'):
	gtkwd_decorator = gtk.RadioMenuItem(label=" GTK Window Decorator")
	gtkwd_decorator.set_group(emerald_decorator)
	gtkwd_decorator.connect("activate", gtkwd_menu_activate)
	if gl_decor_to_run == "gtk-window-decorator --replace":
		gtkwd_decorator.set_active(True)
	decorator_menu.append(gtkwd_decorator)
	item = gtk.SeparatorMenuItem()
	decorator_menu.append(item)
	use_metacity_theme = gtk.CheckMenuItem(label=" Use Metacity Theme")
	if installed('metacity'):
		if metacity_theme_active == True:
			use_metacity_theme.set_active(True)
		else:
			use_metacity_theme.set_active(False)
		use_metacity_theme.connect("activate", use_metacity_activate)
		use_metacity_theme.set_sensitive(True)
	else:
		use_metacity_theme.set_sensitive(False)
	decorator_menu.append(use_metacity_theme)

# Menu		
menu = gtk.Menu()
item = gtk.ImageMenuItem(stock_id=gtk.STOCK_PREFERENCES)
item.connect("activate", configure_menu_activate)
menu.append(item)
item = gtk.ImageMenuItem('Emerald Theme Manager')
item.connect("activate", etm_menu_activate)
img_etm = gtk.Image()
img_etm.set_from_icon_name("emerald-theme-manager-icon", gtk.ICON_SIZE_MENU)
item.set_image(img_etm)
menu.append(item)
item = gtk.SeparatorMenuItem()
menu.append(item)
# Compiz Options
item = gtk.ImageMenuItem("Start/Reload Compiz")
item.connect("activate", compiz_menu_activate)
img_refresh = gtk.Image()
img_refresh.set_from_stock("gtk-refresh", gtk.ICON_SIZE_MENU)
item.set_image(img_refresh)
menu.append(item)
item = gtk.ImageMenuItem("Window Decorator")
gtk.MenuItem.set_submenu(item, decorator_menu)
img_decoration = gtk.Image()
img_decoration.set_from_icon_name("decoration", gtk.ICON_SIZE_MENU)
item.set_image(img_decoration)
menu.append(item)
item = gtk.MenuItem("Compiz Backend")
gtk.MenuItem.set_submenu(item, backend_menu)
menu.append(item)
item = gtk.ImageMenuItem("Compiz Options")
gtk.MenuItem.set_submenu(item, compiz_menu)
img_options = gtk.Image()
img_options.set_from_stock("gtk-properties", gtk.ICON_SIZE_MENU)
item.set_image(img_options)
menu.append(item)
item = gtk.SeparatorMenuItem()
menu.append(item)
# Non-GL Decorators options
if installed('metacity'):
	item = gtk.ImageMenuItem("Start/Reload Metacity")
	item.connect("activate", metacity_menu_activate)
	img_refresh = gtk.Image()
	img_refresh.set_from_stock("gtk-refresh", gtk.ICON_SIZE_MENU)
	item.set_image(img_refresh)
	menu.append(item)
if installed('kwin'):
	item = gtk.MenuItem("Start/Reload Kwin")
	item.connect("activate", kwin_menu_activate)
	menu.append(item)
item = gtk.SeparatorMenuItem()
menu.append(item)
# Quit
item = gtk.ImageMenuItem(stock_id=gtk.STOCK_ABOUT)
item.connect("activate", about_window)
menu.append(item)
item = gtk.ImageMenuItem(stock_id=gtk.STOCK_QUIT)
item.connect("activate", quit_menu_activate)
menu.append(item)
menu.show_all()

pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/go-compiz_compiz.real/icons/22x22/compiz-final.png")
tray = gtk.StatusIcon()
tray.set_from_pixbuf(pixbuf)
tray.connect("popup-menu", go_compiz_menu, menu)

start_decorator_default()
gtk.main()
